<?php
// $Id:

/**
 * @file
 * Given the user, this shows the balance.
 * choose ONE currency from a list of options.
 * note that this is a bit of a pseudo field, since it makes a separate call to the transaction controller layer.
 */
class views_handler_field_mcapi_users_totals extends views_handler_field {

  function query() {
    $this->ensure_my_table();
  }

  function option_definition() {
    $options = parent::option_definition();
    $options['currcode'] = array('default' => key(currencies_load()));
    $options['total'] = array('default' => 'balance');
    return $options;
  }

  function options_form(&$form, &$form_state) {
    module_load_include('inc', 'mcapi');
    $form['currcode'] = currency_picker_element(array_keys(currencies_load()), $this->options['currcode']);
    
    $form['total'] = array(
      '#title' => t('Aggregate'),
      '#description' => t('How do you want to summarise the the transaction totals?'),
      '#type' => 'radios',
      '#options' => array(
        'balance' => t('Balance'),
        'gross_in' => t('Gross income'),
        'gross_out' => t('Gross expenditure'),
        'count' => t('Number of transactions'),
      ),
      '#default_value' => $this->options['total']
    );
    parent::options_form($form, $form_state);
  }

  //note that this requires a separate
  function render($values) {
    $currcodes = is_array($this->options['currcode']) ? $this->options['currcode'] : array($this->options['currcode']);
    $key = $this->options['total'];
    $elements = array('#theme' => 'worth_field_multiple');
    foreach ($currcodes as $currcode) {
      $quant = transaction_totals($values->uid, $currcode)->$key;
      if ($key == 'count') {
        $elements[$currcode] = array('#type' => 'markup', '#markup' => $quant);
      }
      else {
        $elements[$currcode] = array(
          '#theme' => 'worth_field',
          '#quantity' => $quant,
          '#currcode' => $currcode
        );
      }
    }
    return $elements;
  }
}
